.386
.model flat,stdcall
option casemap:none

include mysql-test.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

AdminConnect2MYSQL proc hDlg:DWORD
	invoke mysql_init,addr mysql
	mov conn,eax
	.if eax==NULL
		; insufficient memory
		; do what you want :)
	.endif
	invoke mysql_real_connect,conn,addr szServer,addr szAdminUser,addr szAdminPass,addr szDB,0,NULL,0
	.if eax==NULL
		; error connecting to server
		invoke mysql_error,conn
		invoke wsprintf,addr szError,addr szFmtError,eax
		invoke MessageBox,hDlg,addr szError,addr szErr,MB_ICONERROR
		jmp exit_1
	.endif
  exit_1:
	ret
AdminConnect2MYSQL endp

Query1 proc uses ebx hDlg:DWORD
	LOCAL lpOut1[255]:BYTE
	LOCAL lpOut2[255]:BYTE
	
	invoke SendMessage,hEdit,EM_SETSEL,0,-1
	invoke SendMessage,hEdit,WM_SETTEXT,TRUE,0
	invoke mysql_real_query,conn,addr szQueryEverything,sizeof szQueryEverything
	.if eax!=0
		; SELECT statement is wrong
		invoke mysql_error,conn
		invoke wsprintf,addr szError,addr szFmtError,eax
		invoke MessageBox,hDlg,addr szError,addr szSELErr,MB_ICONERROR
		jmp exit_2
	.endif
	invoke mysql_use_result,conn
	.if eax==NULL
		; Error
		invoke mysql_error,conn
		invoke wsprintf,addr szError,addr szFmtError,eax
		invoke MessageBox,hDlg,addr szError,addr szErrRes,MB_ICONERROR
		jmp exit_2
	.endif
	mov res,eax
	.while TRUE
		; take every row
		invoke mysql_fetch_row,res
		mov ebx,eax
		test ebx,ebx
		jz exit_2
		; if we set * in SELECT then we will get value from every field
		; so if we have 5 fields, we have 5 values
		; if we write only eg. 2 fields (col3 and col4 in SELECT statement) we will get only
		; these 2 fileds value from every row
		; ebx is first field value, ebx+4 second, ebx+8 third, etc.
		; print everything on screen
		invoke wsprintf,addr lpOut1,addr lpOutFmt,dword ptr [ebx],dword ptr [ebx+4],dword ptr [ebx+8],dword ptr [ebx+12],dword ptr [ebx+16]
		invoke SendMessage,hEdit,EM_SETSEL,-1,0
		invoke SendMessage,hEdit,EM_REPLACESEL,FALSE,addr lpOut1
	.endw
  exit_2:
  	; free result
	invoke mysql_free_result,res
	; close connection
	invoke mysql_close,conn
	ret
Query1 endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		invoke GetDlgItem,hWin,IDC_EDT1
		mov hEdit,eax
		invoke AdminConnect2MYSQL,hWnd
		invoke Query1,hWnd

	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif
;	.elseif eax==WM_SIZE
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
